// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_denm_msgs:msg/AlacarteContainer.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_denm_msgs/msg/alacarte_container.hpp"


#ifndef ETSI_ITS_DENM_MSGS__MSG__DETAIL__ALACARTE_CONTAINER__STRUCT_HPP_
#define ETSI_ITS_DENM_MSGS__MSG__DETAIL__ALACARTE_CONTAINER__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'lane_position'
#include "etsi_its_denm_msgs/msg/detail/lane_position__struct.hpp"
// Member 'impact_reduction'
#include "etsi_its_denm_msgs/msg/detail/impact_reduction_container__struct.hpp"
// Member 'external_temperature'
#include "etsi_its_denm_msgs/msg/detail/temperature__struct.hpp"
// Member 'road_works'
#include "etsi_its_denm_msgs/msg/detail/road_works_container_extended__struct.hpp"
// Member 'positioning_solution'
#include "etsi_its_denm_msgs/msg/detail/positioning_solution_type__struct.hpp"
// Member 'stationary_vehicle'
#include "etsi_its_denm_msgs/msg/detail/stationary_vehicle_container__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_denm_msgs__msg__AlacarteContainer __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_denm_msgs__msg__AlacarteContainer __declspec(deprecated)
#endif

namespace etsi_its_denm_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct AlacarteContainer_
{
  using Type = AlacarteContainer_<ContainerAllocator>;

  explicit AlacarteContainer_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : lane_position(_init),
    impact_reduction(_init),
    external_temperature(_init),
    road_works(_init),
    positioning_solution(_init),
    stationary_vehicle(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->lane_position_is_present = false;
      this->impact_reduction_is_present = false;
      this->external_temperature_is_present = false;
      this->road_works_is_present = false;
      this->positioning_solution_is_present = false;
      this->stationary_vehicle_is_present = false;
    }
  }

  explicit AlacarteContainer_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : lane_position(_alloc, _init),
    impact_reduction(_alloc, _init),
    external_temperature(_alloc, _init),
    road_works(_alloc, _init),
    positioning_solution(_alloc, _init),
    stationary_vehicle(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->lane_position_is_present = false;
      this->impact_reduction_is_present = false;
      this->external_temperature_is_present = false;
      this->road_works_is_present = false;
      this->positioning_solution_is_present = false;
      this->stationary_vehicle_is_present = false;
    }
  }

  // field types and members
  using _lane_position_type =
    etsi_its_denm_msgs::msg::LanePosition_<ContainerAllocator>;
  _lane_position_type lane_position;
  using _lane_position_is_present_type =
    bool;
  _lane_position_is_present_type lane_position_is_present;
  using _impact_reduction_type =
    etsi_its_denm_msgs::msg::ImpactReductionContainer_<ContainerAllocator>;
  _impact_reduction_type impact_reduction;
  using _impact_reduction_is_present_type =
    bool;
  _impact_reduction_is_present_type impact_reduction_is_present;
  using _external_temperature_type =
    etsi_its_denm_msgs::msg::Temperature_<ContainerAllocator>;
  _external_temperature_type external_temperature;
  using _external_temperature_is_present_type =
    bool;
  _external_temperature_is_present_type external_temperature_is_present;
  using _road_works_type =
    etsi_its_denm_msgs::msg::RoadWorksContainerExtended_<ContainerAllocator>;
  _road_works_type road_works;
  using _road_works_is_present_type =
    bool;
  _road_works_is_present_type road_works_is_present;
  using _positioning_solution_type =
    etsi_its_denm_msgs::msg::PositioningSolutionType_<ContainerAllocator>;
  _positioning_solution_type positioning_solution;
  using _positioning_solution_is_present_type =
    bool;
  _positioning_solution_is_present_type positioning_solution_is_present;
  using _stationary_vehicle_type =
    etsi_its_denm_msgs::msg::StationaryVehicleContainer_<ContainerAllocator>;
  _stationary_vehicle_type stationary_vehicle;
  using _stationary_vehicle_is_present_type =
    bool;
  _stationary_vehicle_is_present_type stationary_vehicle_is_present;

  // setters for named parameter idiom
  Type & set__lane_position(
    const etsi_its_denm_msgs::msg::LanePosition_<ContainerAllocator> & _arg)
  {
    this->lane_position = _arg;
    return *this;
  }
  Type & set__lane_position_is_present(
    const bool & _arg)
  {
    this->lane_position_is_present = _arg;
    return *this;
  }
  Type & set__impact_reduction(
    const etsi_its_denm_msgs::msg::ImpactReductionContainer_<ContainerAllocator> & _arg)
  {
    this->impact_reduction = _arg;
    return *this;
  }
  Type & set__impact_reduction_is_present(
    const bool & _arg)
  {
    this->impact_reduction_is_present = _arg;
    return *this;
  }
  Type & set__external_temperature(
    const etsi_its_denm_msgs::msg::Temperature_<ContainerAllocator> & _arg)
  {
    this->external_temperature = _arg;
    return *this;
  }
  Type & set__external_temperature_is_present(
    const bool & _arg)
  {
    this->external_temperature_is_present = _arg;
    return *this;
  }
  Type & set__road_works(
    const etsi_its_denm_msgs::msg::RoadWorksContainerExtended_<ContainerAllocator> & _arg)
  {
    this->road_works = _arg;
    return *this;
  }
  Type & set__road_works_is_present(
    const bool & _arg)
  {
    this->road_works_is_present = _arg;
    return *this;
  }
  Type & set__positioning_solution(
    const etsi_its_denm_msgs::msg::PositioningSolutionType_<ContainerAllocator> & _arg)
  {
    this->positioning_solution = _arg;
    return *this;
  }
  Type & set__positioning_solution_is_present(
    const bool & _arg)
  {
    this->positioning_solution_is_present = _arg;
    return *this;
  }
  Type & set__stationary_vehicle(
    const etsi_its_denm_msgs::msg::StationaryVehicleContainer_<ContainerAllocator> & _arg)
  {
    this->stationary_vehicle = _arg;
    return *this;
  }
  Type & set__stationary_vehicle_is_present(
    const bool & _arg)
  {
    this->stationary_vehicle_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_denm_msgs::msg::AlacarteContainer_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_denm_msgs::msg::AlacarteContainer_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_denm_msgs::msg::AlacarteContainer_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_denm_msgs::msg::AlacarteContainer_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_msgs::msg::AlacarteContainer_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_msgs::msg::AlacarteContainer_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_msgs::msg::AlacarteContainer_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_msgs::msg::AlacarteContainer_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_denm_msgs::msg::AlacarteContainer_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_denm_msgs::msg::AlacarteContainer_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_denm_msgs__msg__AlacarteContainer
    std::shared_ptr<etsi_its_denm_msgs::msg::AlacarteContainer_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_denm_msgs__msg__AlacarteContainer
    std::shared_ptr<etsi_its_denm_msgs::msg::AlacarteContainer_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const AlacarteContainer_ & other) const
  {
    if (this->lane_position != other.lane_position) {
      return false;
    }
    if (this->lane_position_is_present != other.lane_position_is_present) {
      return false;
    }
    if (this->impact_reduction != other.impact_reduction) {
      return false;
    }
    if (this->impact_reduction_is_present != other.impact_reduction_is_present) {
      return false;
    }
    if (this->external_temperature != other.external_temperature) {
      return false;
    }
    if (this->external_temperature_is_present != other.external_temperature_is_present) {
      return false;
    }
    if (this->road_works != other.road_works) {
      return false;
    }
    if (this->road_works_is_present != other.road_works_is_present) {
      return false;
    }
    if (this->positioning_solution != other.positioning_solution) {
      return false;
    }
    if (this->positioning_solution_is_present != other.positioning_solution_is_present) {
      return false;
    }
    if (this->stationary_vehicle != other.stationary_vehicle) {
      return false;
    }
    if (this->stationary_vehicle_is_present != other.stationary_vehicle_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const AlacarteContainer_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct AlacarteContainer_

// alias to use template instance with default allocator
using AlacarteContainer =
  etsi_its_denm_msgs::msg::AlacarteContainer_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_denm_msgs

#endif  // ETSI_ITS_DENM_MSGS__MSG__DETAIL__ALACARTE_CONTAINER__STRUCT_HPP_
