// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_denm_msgs:msg/PosConfidenceEllipse.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_denm_msgs/msg/pos_confidence_ellipse.h"


#ifndef ETSI_ITS_DENM_MSGS__MSG__DETAIL__POS_CONFIDENCE_ELLIPSE__STRUCT_H_
#define ETSI_ITS_DENM_MSGS__MSG__DETAIL__POS_CONFIDENCE_ELLIPSE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'semi_major_confidence'
// Member 'semi_minor_confidence'
#include "etsi_its_denm_msgs/msg/detail/semi_axis_length__struct.h"
// Member 'semi_major_orientation'
#include "etsi_its_denm_msgs/msg/detail/heading_value__struct.h"

/// Struct defined in msg/PosConfidenceEllipse in the package etsi_its_denm_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_denm_msgs__msg__PosConfidenceEllipse
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// PosConfidenceEllipse ::= SEQUENCE {
  ///     semiMajorConfidence SemiAxisLength,
  ///     semiMinorConfidence SemiAxisLength,
  ///     semiMajorOrientation HeadingValue
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_denm_msgs__msg__SemiAxisLength semi_major_confidence;
  etsi_its_denm_msgs__msg__SemiAxisLength semi_minor_confidence;
  etsi_its_denm_msgs__msg__HeadingValue semi_major_orientation;
} etsi_its_denm_msgs__msg__PosConfidenceEllipse;

// Struct for a sequence of etsi_its_denm_msgs__msg__PosConfidenceEllipse.
typedef struct etsi_its_denm_msgs__msg__PosConfidenceEllipse__Sequence
{
  etsi_its_denm_msgs__msg__PosConfidenceEllipse * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_denm_msgs__msg__PosConfidenceEllipse__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_DENM_MSGS__MSG__DETAIL__POS_CONFIDENCE_ELLIPSE__STRUCT_H_
