// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_denm_msgs:msg/VehicleIdentification.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_denm_msgs/msg/vehicle_identification.hpp"


#ifndef ETSI_ITS_DENM_MSGS__MSG__DETAIL__VEHICLE_IDENTIFICATION__TRAITS_HPP_
#define ETSI_ITS_DENM_MSGS__MSG__DETAIL__VEHICLE_IDENTIFICATION__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_denm_msgs/msg/detail/vehicle_identification__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'wm_inumber'
#include "etsi_its_denm_msgs/msg/detail/wm_inumber__traits.hpp"
// Member 'vds'
#include "etsi_its_denm_msgs/msg/detail/vds__traits.hpp"

namespace etsi_its_denm_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const VehicleIdentification & msg,
  std::ostream & out)
{
  out << "{";
  // member: wm_inumber
  {
    out << "wm_inumber: ";
    to_flow_style_yaml(msg.wm_inumber, out);
    out << ", ";
  }

  // member: wm_inumber_is_present
  {
    out << "wm_inumber_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.wm_inumber_is_present, out);
    out << ", ";
  }

  // member: vds
  {
    out << "vds: ";
    to_flow_style_yaml(msg.vds, out);
    out << ", ";
  }

  // member: vds_is_present
  {
    out << "vds_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.vds_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const VehicleIdentification & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: wm_inumber
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "wm_inumber:\n";
    to_block_style_yaml(msg.wm_inumber, out, indentation + 2);
  }

  // member: wm_inumber_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "wm_inumber_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.wm_inumber_is_present, out);
    out << "\n";
  }

  // member: vds
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "vds:\n";
    to_block_style_yaml(msg.vds, out, indentation + 2);
  }

  // member: vds_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "vds_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.vds_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const VehicleIdentification & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_denm_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_denm_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_denm_msgs::msg::VehicleIdentification & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_denm_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_denm_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_denm_msgs::msg::VehicleIdentification & msg)
{
  return etsi_its_denm_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_denm_msgs::msg::VehicleIdentification>()
{
  return "etsi_its_denm_msgs::msg::VehicleIdentification";
}

template<>
inline const char * name<etsi_its_denm_msgs::msg::VehicleIdentification>()
{
  return "etsi_its_denm_msgs/msg/VehicleIdentification";
}

template<>
struct has_fixed_size<etsi_its_denm_msgs::msg::VehicleIdentification>
  : std::integral_constant<bool, has_fixed_size<etsi_its_denm_msgs::msg::VDS>::value && has_fixed_size<etsi_its_denm_msgs::msg::WMInumber>::value> {};

template<>
struct has_bounded_size<etsi_its_denm_msgs::msg::VehicleIdentification>
  : std::integral_constant<bool, has_bounded_size<etsi_its_denm_msgs::msg::VDS>::value && has_bounded_size<etsi_its_denm_msgs::msg::WMInumber>::value> {};

template<>
struct is_message<etsi_its_denm_msgs::msg::VehicleIdentification>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_DENM_MSGS__MSG__DETAIL__VEHICLE_IDENTIFICATION__TRAITS_HPP_
