// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_denm_msgs:msg/AlacarteContainer.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_denm_msgs/msg/alacarte_container.h"


#ifndef ETSI_ITS_DENM_MSGS__MSG__DETAIL__ALACARTE_CONTAINER__STRUCT_H_
#define ETSI_ITS_DENM_MSGS__MSG__DETAIL__ALACARTE_CONTAINER__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'lane_position'
#include "etsi_its_denm_msgs/msg/detail/lane_position__struct.h"
// Member 'impact_reduction'
#include "etsi_its_denm_msgs/msg/detail/impact_reduction_container__struct.h"
// Member 'external_temperature'
#include "etsi_its_denm_msgs/msg/detail/temperature__struct.h"
// Member 'road_works'
#include "etsi_its_denm_msgs/msg/detail/road_works_container_extended__struct.h"
// Member 'positioning_solution'
#include "etsi_its_denm_msgs/msg/detail/positioning_solution_type__struct.h"
// Member 'stationary_vehicle'
#include "etsi_its_denm_msgs/msg/detail/stationary_vehicle_container__struct.h"

/// Struct defined in msg/AlacarteContainer in the package etsi_its_denm_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_denm_msgs__msg__AlacarteContainer
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// AlacarteContainer ::= SEQUENCE {
  ///  lanePosition LanePosition OPTIONAL,
  ///  impactReduction ImpactReductionContainer OPTIONAL,
  ///  externalTemperature Temperature OPTIONAL,
  ///  roadWorks RoadWorksContainerExtended OPTIONAL,
  ///  positioningSolution PositioningSolutionType OPTIONAL,
  ///  stationaryVehicle StationaryVehicleContainer OPTIONAL,
  ///  ...
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_denm_msgs__msg__LanePosition lane_position;
  bool lane_position_is_present;
  etsi_its_denm_msgs__msg__ImpactReductionContainer impact_reduction;
  bool impact_reduction_is_present;
  etsi_its_denm_msgs__msg__Temperature external_temperature;
  bool external_temperature_is_present;
  etsi_its_denm_msgs__msg__RoadWorksContainerExtended road_works;
  bool road_works_is_present;
  etsi_its_denm_msgs__msg__PositioningSolutionType positioning_solution;
  bool positioning_solution_is_present;
  etsi_its_denm_msgs__msg__StationaryVehicleContainer stationary_vehicle;
  bool stationary_vehicle_is_present;
} etsi_its_denm_msgs__msg__AlacarteContainer;

// Struct for a sequence of etsi_its_denm_msgs__msg__AlacarteContainer.
typedef struct etsi_its_denm_msgs__msg__AlacarteContainer__Sequence
{
  etsi_its_denm_msgs__msg__AlacarteContainer * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_denm_msgs__msg__AlacarteContainer__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_DENM_MSGS__MSG__DETAIL__ALACARTE_CONTAINER__STRUCT_H_
