// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_denm_msgs:msg/AlacarteContainer.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_denm_msgs/msg/alacarte_container.hpp"


#ifndef ETSI_ITS_DENM_MSGS__MSG__DETAIL__ALACARTE_CONTAINER__TRAITS_HPP_
#define ETSI_ITS_DENM_MSGS__MSG__DETAIL__ALACARTE_CONTAINER__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_denm_msgs/msg/detail/alacarte_container__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'lane_position'
#include "etsi_its_denm_msgs/msg/detail/lane_position__traits.hpp"
// Member 'impact_reduction'
#include "etsi_its_denm_msgs/msg/detail/impact_reduction_container__traits.hpp"
// Member 'external_temperature'
#include "etsi_its_denm_msgs/msg/detail/temperature__traits.hpp"
// Member 'road_works'
#include "etsi_its_denm_msgs/msg/detail/road_works_container_extended__traits.hpp"
// Member 'positioning_solution'
#include "etsi_its_denm_msgs/msg/detail/positioning_solution_type__traits.hpp"
// Member 'stationary_vehicle'
#include "etsi_its_denm_msgs/msg/detail/stationary_vehicle_container__traits.hpp"

namespace etsi_its_denm_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const AlacarteContainer & msg,
  std::ostream & out)
{
  out << "{";
  // member: lane_position
  {
    out << "lane_position: ";
    to_flow_style_yaml(msg.lane_position, out);
    out << ", ";
  }

  // member: lane_position_is_present
  {
    out << "lane_position_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.lane_position_is_present, out);
    out << ", ";
  }

  // member: impact_reduction
  {
    out << "impact_reduction: ";
    to_flow_style_yaml(msg.impact_reduction, out);
    out << ", ";
  }

  // member: impact_reduction_is_present
  {
    out << "impact_reduction_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.impact_reduction_is_present, out);
    out << ", ";
  }

  // member: external_temperature
  {
    out << "external_temperature: ";
    to_flow_style_yaml(msg.external_temperature, out);
    out << ", ";
  }

  // member: external_temperature_is_present
  {
    out << "external_temperature_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.external_temperature_is_present, out);
    out << ", ";
  }

  // member: road_works
  {
    out << "road_works: ";
    to_flow_style_yaml(msg.road_works, out);
    out << ", ";
  }

  // member: road_works_is_present
  {
    out << "road_works_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.road_works_is_present, out);
    out << ", ";
  }

  // member: positioning_solution
  {
    out << "positioning_solution: ";
    to_flow_style_yaml(msg.positioning_solution, out);
    out << ", ";
  }

  // member: positioning_solution_is_present
  {
    out << "positioning_solution_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.positioning_solution_is_present, out);
    out << ", ";
  }

  // member: stationary_vehicle
  {
    out << "stationary_vehicle: ";
    to_flow_style_yaml(msg.stationary_vehicle, out);
    out << ", ";
  }

  // member: stationary_vehicle_is_present
  {
    out << "stationary_vehicle_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.stationary_vehicle_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const AlacarteContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: lane_position
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "lane_position:\n";
    to_block_style_yaml(msg.lane_position, out, indentation + 2);
  }

  // member: lane_position_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "lane_position_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.lane_position_is_present, out);
    out << "\n";
  }

  // member: impact_reduction
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "impact_reduction:\n";
    to_block_style_yaml(msg.impact_reduction, out, indentation + 2);
  }

  // member: impact_reduction_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "impact_reduction_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.impact_reduction_is_present, out);
    out << "\n";
  }

  // member: external_temperature
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "external_temperature:\n";
    to_block_style_yaml(msg.external_temperature, out, indentation + 2);
  }

  // member: external_temperature_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "external_temperature_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.external_temperature_is_present, out);
    out << "\n";
  }

  // member: road_works
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "road_works:\n";
    to_block_style_yaml(msg.road_works, out, indentation + 2);
  }

  // member: road_works_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "road_works_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.road_works_is_present, out);
    out << "\n";
  }

  // member: positioning_solution
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "positioning_solution:\n";
    to_block_style_yaml(msg.positioning_solution, out, indentation + 2);
  }

  // member: positioning_solution_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "positioning_solution_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.positioning_solution_is_present, out);
    out << "\n";
  }

  // member: stationary_vehicle
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "stationary_vehicle:\n";
    to_block_style_yaml(msg.stationary_vehicle, out, indentation + 2);
  }

  // member: stationary_vehicle_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "stationary_vehicle_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.stationary_vehicle_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const AlacarteContainer & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_denm_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_denm_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_denm_msgs::msg::AlacarteContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_denm_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_denm_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_denm_msgs::msg::AlacarteContainer & msg)
{
  return etsi_its_denm_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_denm_msgs::msg::AlacarteContainer>()
{
  return "etsi_its_denm_msgs::msg::AlacarteContainer";
}

template<>
inline const char * name<etsi_its_denm_msgs::msg::AlacarteContainer>()
{
  return "etsi_its_denm_msgs/msg/AlacarteContainer";
}

template<>
struct has_fixed_size<etsi_its_denm_msgs::msg::AlacarteContainer>
  : std::integral_constant<bool, has_fixed_size<etsi_its_denm_msgs::msg::ImpactReductionContainer>::value && has_fixed_size<etsi_its_denm_msgs::msg::LanePosition>::value && has_fixed_size<etsi_its_denm_msgs::msg::PositioningSolutionType>::value && has_fixed_size<etsi_its_denm_msgs::msg::RoadWorksContainerExtended>::value && has_fixed_size<etsi_its_denm_msgs::msg::StationaryVehicleContainer>::value && has_fixed_size<etsi_its_denm_msgs::msg::Temperature>::value> {};

template<>
struct has_bounded_size<etsi_its_denm_msgs::msg::AlacarteContainer>
  : std::integral_constant<bool, has_bounded_size<etsi_its_denm_msgs::msg::ImpactReductionContainer>::value && has_bounded_size<etsi_its_denm_msgs::msg::LanePosition>::value && has_bounded_size<etsi_its_denm_msgs::msg::PositioningSolutionType>::value && has_bounded_size<etsi_its_denm_msgs::msg::RoadWorksContainerExtended>::value && has_bounded_size<etsi_its_denm_msgs::msg::StationaryVehicleContainer>::value && has_bounded_size<etsi_its_denm_msgs::msg::Temperature>::value> {};

template<>
struct is_message<etsi_its_denm_msgs::msg::AlacarteContainer>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_DENM_MSGS__MSG__DETAIL__ALACARTE_CONTAINER__TRAITS_HPP_
