// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_denm_msgs:msg/DENM.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_denm_msgs/msg/denm.hpp"


#ifndef ETSI_ITS_DENM_MSGS__MSG__DETAIL__DENM__STRUCT_HPP_
#define ETSI_ITS_DENM_MSGS__MSG__DETAIL__DENM__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "etsi_its_denm_msgs/msg/detail/its_pdu_header__struct.hpp"
// Member 'denm'
#include "etsi_its_denm_msgs/msg/detail/decentralized_environmental_notification_message__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_denm_msgs__msg__DENM __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_denm_msgs__msg__DENM __declspec(deprecated)
#endif

namespace etsi_its_denm_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct DENM_
{
  using Type = DENM_<ContainerAllocator>;

  explicit DENM_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    denm(_init)
  {
    (void)_init;
  }

  explicit DENM_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    denm(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _header_type =
    etsi_its_denm_msgs::msg::ItsPduHeader_<ContainerAllocator>;
  _header_type header;
  using _denm_type =
    etsi_its_denm_msgs::msg::DecentralizedEnvironmentalNotificationMessage_<ContainerAllocator>;
  _denm_type denm;

  // setters for named parameter idiom
  Type & set__header(
    const etsi_its_denm_msgs::msg::ItsPduHeader_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__denm(
    const etsi_its_denm_msgs::msg::DecentralizedEnvironmentalNotificationMessage_<ContainerAllocator> & _arg)
  {
    this->denm = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_denm_msgs::msg::DENM_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_denm_msgs::msg::DENM_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_denm_msgs::msg::DENM_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_denm_msgs::msg::DENM_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_msgs::msg::DENM_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_msgs::msg::DENM_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_msgs::msg::DENM_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_msgs::msg::DENM_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_denm_msgs::msg::DENM_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_denm_msgs::msg::DENM_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_denm_msgs__msg__DENM
    std::shared_ptr<etsi_its_denm_msgs::msg::DENM_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_denm_msgs__msg__DENM
    std::shared_ptr<etsi_its_denm_msgs::msg::DENM_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DENM_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->denm != other.denm) {
      return false;
    }
    return true;
  }
  bool operator!=(const DENM_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DENM_

// alias to use template instance with default allocator
using DENM =
  etsi_its_denm_msgs::msg::DENM_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_denm_msgs

#endif  // ETSI_ITS_DENM_MSGS__MSG__DETAIL__DENM__STRUCT_HPP_
