// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_denm_msgs:msg/EventPoint.idl
// generated code does not contain a copyright notice
#include "etsi_its_denm_msgs/msg/detail/event_point__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `event_position`
#include "etsi_its_denm_msgs/msg/detail/delta_reference_position__functions.h"
// Member `event_delta_time`
#include "etsi_its_denm_msgs/msg/detail/path_delta_time__functions.h"
// Member `information_quality`
#include "etsi_its_denm_msgs/msg/detail/information_quality__functions.h"

bool
etsi_its_denm_msgs__msg__EventPoint__init(etsi_its_denm_msgs__msg__EventPoint * msg)
{
  if (!msg) {
    return false;
  }
  // event_position
  if (!etsi_its_denm_msgs__msg__DeltaReferencePosition__init(&msg->event_position)) {
    etsi_its_denm_msgs__msg__EventPoint__fini(msg);
    return false;
  }
  // event_delta_time
  if (!etsi_its_denm_msgs__msg__PathDeltaTime__init(&msg->event_delta_time)) {
    etsi_its_denm_msgs__msg__EventPoint__fini(msg);
    return false;
  }
  // event_delta_time_is_present
  // information_quality
  if (!etsi_its_denm_msgs__msg__InformationQuality__init(&msg->information_quality)) {
    etsi_its_denm_msgs__msg__EventPoint__fini(msg);
    return false;
  }
  return true;
}

void
etsi_its_denm_msgs__msg__EventPoint__fini(etsi_its_denm_msgs__msg__EventPoint * msg)
{
  if (!msg) {
    return;
  }
  // event_position
  etsi_its_denm_msgs__msg__DeltaReferencePosition__fini(&msg->event_position);
  // event_delta_time
  etsi_its_denm_msgs__msg__PathDeltaTime__fini(&msg->event_delta_time);
  // event_delta_time_is_present
  // information_quality
  etsi_its_denm_msgs__msg__InformationQuality__fini(&msg->information_quality);
}

bool
etsi_its_denm_msgs__msg__EventPoint__are_equal(const etsi_its_denm_msgs__msg__EventPoint * lhs, const etsi_its_denm_msgs__msg__EventPoint * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // event_position
  if (!etsi_its_denm_msgs__msg__DeltaReferencePosition__are_equal(
      &(lhs->event_position), &(rhs->event_position)))
  {
    return false;
  }
  // event_delta_time
  if (!etsi_its_denm_msgs__msg__PathDeltaTime__are_equal(
      &(lhs->event_delta_time), &(rhs->event_delta_time)))
  {
    return false;
  }
  // event_delta_time_is_present
  if (lhs->event_delta_time_is_present != rhs->event_delta_time_is_present) {
    return false;
  }
  // information_quality
  if (!etsi_its_denm_msgs__msg__InformationQuality__are_equal(
      &(lhs->information_quality), &(rhs->information_quality)))
  {
    return false;
  }
  return true;
}

bool
etsi_its_denm_msgs__msg__EventPoint__copy(
  const etsi_its_denm_msgs__msg__EventPoint * input,
  etsi_its_denm_msgs__msg__EventPoint * output)
{
  if (!input || !output) {
    return false;
  }
  // event_position
  if (!etsi_its_denm_msgs__msg__DeltaReferencePosition__copy(
      &(input->event_position), &(output->event_position)))
  {
    return false;
  }
  // event_delta_time
  if (!etsi_its_denm_msgs__msg__PathDeltaTime__copy(
      &(input->event_delta_time), &(output->event_delta_time)))
  {
    return false;
  }
  // event_delta_time_is_present
  output->event_delta_time_is_present = input->event_delta_time_is_present;
  // information_quality
  if (!etsi_its_denm_msgs__msg__InformationQuality__copy(
      &(input->information_quality), &(output->information_quality)))
  {
    return false;
  }
  return true;
}

etsi_its_denm_msgs__msg__EventPoint *
etsi_its_denm_msgs__msg__EventPoint__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_denm_msgs__msg__EventPoint * msg = (etsi_its_denm_msgs__msg__EventPoint *)allocator.allocate(sizeof(etsi_its_denm_msgs__msg__EventPoint), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_denm_msgs__msg__EventPoint));
  bool success = etsi_its_denm_msgs__msg__EventPoint__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_denm_msgs__msg__EventPoint__destroy(etsi_its_denm_msgs__msg__EventPoint * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_denm_msgs__msg__EventPoint__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_denm_msgs__msg__EventPoint__Sequence__init(etsi_its_denm_msgs__msg__EventPoint__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_denm_msgs__msg__EventPoint * data = NULL;

  if (size) {
    data = (etsi_its_denm_msgs__msg__EventPoint *)allocator.zero_allocate(size, sizeof(etsi_its_denm_msgs__msg__EventPoint), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_denm_msgs__msg__EventPoint__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_denm_msgs__msg__EventPoint__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_denm_msgs__msg__EventPoint__Sequence__fini(etsi_its_denm_msgs__msg__EventPoint__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_denm_msgs__msg__EventPoint__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_denm_msgs__msg__EventPoint__Sequence *
etsi_its_denm_msgs__msg__EventPoint__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_denm_msgs__msg__EventPoint__Sequence * array = (etsi_its_denm_msgs__msg__EventPoint__Sequence *)allocator.allocate(sizeof(etsi_its_denm_msgs__msg__EventPoint__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_denm_msgs__msg__EventPoint__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_denm_msgs__msg__EventPoint__Sequence__destroy(etsi_its_denm_msgs__msg__EventPoint__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_denm_msgs__msg__EventPoint__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_denm_msgs__msg__EventPoint__Sequence__are_equal(const etsi_its_denm_msgs__msg__EventPoint__Sequence * lhs, const etsi_its_denm_msgs__msg__EventPoint__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_denm_msgs__msg__EventPoint__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_denm_msgs__msg__EventPoint__Sequence__copy(
  const etsi_its_denm_msgs__msg__EventPoint__Sequence * input,
  etsi_its_denm_msgs__msg__EventPoint__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_denm_msgs__msg__EventPoint);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_denm_msgs__msg__EventPoint * data =
      (etsi_its_denm_msgs__msg__EventPoint *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_denm_msgs__msg__EventPoint__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_denm_msgs__msg__EventPoint__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_denm_msgs__msg__EventPoint__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
