// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_denm_msgs:msg/ItsPduHeader.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_denm_msgs/msg/its_pdu_header.h"


#ifndef ETSI_ITS_DENM_MSGS__MSG__DETAIL__ITS_PDU_HEADER__STRUCT_H_
#define ETSI_ITS_DENM_MSGS__MSG__DETAIL__ITS_PDU_HEADER__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'PROTOCOL_VERSION_MIN'.
enum
{
  etsi_its_denm_msgs__msg__ItsPduHeader__PROTOCOL_VERSION_MIN = 0
};

/// Constant 'PROTOCOL_VERSION_MAX'.
enum
{
  etsi_its_denm_msgs__msg__ItsPduHeader__PROTOCOL_VERSION_MAX = 255
};

/// Constant 'MESSAGE_ID_MIN'.
enum
{
  etsi_its_denm_msgs__msg__ItsPduHeader__MESSAGE_ID_MIN = 0
};

/// Constant 'MESSAGE_ID_MAX'.
enum
{
  etsi_its_denm_msgs__msg__ItsPduHeader__MESSAGE_ID_MAX = 255
};

/// Constant 'MESSAGE_ID_DENM'.
enum
{
  etsi_its_denm_msgs__msg__ItsPduHeader__MESSAGE_ID_DENM = 1
};

/// Constant 'MESSAGE_ID_CAM'.
enum
{
  etsi_its_denm_msgs__msg__ItsPduHeader__MESSAGE_ID_CAM = 2
};

/// Constant 'MESSAGE_ID_POI'.
enum
{
  etsi_its_denm_msgs__msg__ItsPduHeader__MESSAGE_ID_POI = 3
};

/// Constant 'MESSAGE_ID_SPATEM'.
enum
{
  etsi_its_denm_msgs__msg__ItsPduHeader__MESSAGE_ID_SPATEM = 4
};

/// Constant 'MESSAGE_ID_MAPEM'.
enum
{
  etsi_its_denm_msgs__msg__ItsPduHeader__MESSAGE_ID_MAPEM = 5
};

/// Constant 'MESSAGE_ID_IVIM'.
enum
{
  etsi_its_denm_msgs__msg__ItsPduHeader__MESSAGE_ID_IVIM = 6
};

/// Constant 'MESSAGE_ID_EV_RSR'.
enum
{
  etsi_its_denm_msgs__msg__ItsPduHeader__MESSAGE_ID_EV_RSR = 7
};

/// Constant 'MESSAGE_ID_TISTPGTRANSACTION'.
enum
{
  etsi_its_denm_msgs__msg__ItsPduHeader__MESSAGE_ID_TISTPGTRANSACTION = 8
};

/// Constant 'MESSAGE_ID_SREM'.
enum
{
  etsi_its_denm_msgs__msg__ItsPduHeader__MESSAGE_ID_SREM = 9
};

/// Constant 'MESSAGE_ID_SSEM'.
enum
{
  etsi_its_denm_msgs__msg__ItsPduHeader__MESSAGE_ID_SSEM = 10
};

/// Constant 'MESSAGE_ID_EVCSN'.
enum
{
  etsi_its_denm_msgs__msg__ItsPduHeader__MESSAGE_ID_EVCSN = 11
};

/// Constant 'MESSAGE_ID_SAEM'.
enum
{
  etsi_its_denm_msgs__msg__ItsPduHeader__MESSAGE_ID_SAEM = 12
};

/// Constant 'MESSAGE_ID_RTCMEM'.
enum
{
  etsi_its_denm_msgs__msg__ItsPduHeader__MESSAGE_ID_RTCMEM = 13
};

// Include directives for member types
// Member 'station_id'
#include "etsi_its_denm_msgs/msg/detail/station_id__struct.h"

/// Struct defined in msg/ItsPduHeader in the package etsi_its_denm_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_denm_msgs__msg__ItsPduHeader
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// ItsPduHeader ::= SEQUENCE {
  ///     protocolVersion INTEGER (0..255),
  ///     messageID INTEGER{ denm(1), cam(2), poi(3), spatem(4), mapem(5), ivim(6), ev-rsr(7), tistpgtransaction(8), srem(9), ssem(10), evcsn(11), saem(12), rtcmem(13) } (0..255),  -- Mantis #7209, #7005
  /// ------------------------------------------------------------------------------
  uint8_t protocol_version;
  uint8_t message_id;
  etsi_its_denm_msgs__msg__StationID station_id;
} etsi_its_denm_msgs__msg__ItsPduHeader;

// Struct for a sequence of etsi_its_denm_msgs__msg__ItsPduHeader.
typedef struct etsi_its_denm_msgs__msg__ItsPduHeader__Sequence
{
  etsi_its_denm_msgs__msg__ItsPduHeader * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_denm_msgs__msg__ItsPduHeader__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_DENM_MSGS__MSG__DETAIL__ITS_PDU_HEADER__STRUCT_H_
