// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_denm_msgs:msg/ItsPduHeader.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_denm_msgs/msg/its_pdu_header.hpp"


#ifndef ETSI_ITS_DENM_MSGS__MSG__DETAIL__ITS_PDU_HEADER__STRUCT_HPP_
#define ETSI_ITS_DENM_MSGS__MSG__DETAIL__ITS_PDU_HEADER__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'station_id'
#include "etsi_its_denm_msgs/msg/detail/station_id__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_denm_msgs__msg__ItsPduHeader __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_denm_msgs__msg__ItsPduHeader __declspec(deprecated)
#endif

namespace etsi_its_denm_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ItsPduHeader_
{
  using Type = ItsPduHeader_<ContainerAllocator>;

  explicit ItsPduHeader_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : station_id(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->protocol_version = 0;
      this->message_id = 0;
    }
  }

  explicit ItsPduHeader_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : station_id(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->protocol_version = 0;
      this->message_id = 0;
    }
  }

  // field types and members
  using _protocol_version_type =
    uint8_t;
  _protocol_version_type protocol_version;
  using _message_id_type =
    uint8_t;
  _message_id_type message_id;
  using _station_id_type =
    etsi_its_denm_msgs::msg::StationID_<ContainerAllocator>;
  _station_id_type station_id;

  // setters for named parameter idiom
  Type & set__protocol_version(
    const uint8_t & _arg)
  {
    this->protocol_version = _arg;
    return *this;
  }
  Type & set__message_id(
    const uint8_t & _arg)
  {
    this->message_id = _arg;
    return *this;
  }
  Type & set__station_id(
    const etsi_its_denm_msgs::msg::StationID_<ContainerAllocator> & _arg)
  {
    this->station_id = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t PROTOCOL_VERSION_MIN =
    0u;
  static constexpr uint8_t PROTOCOL_VERSION_MAX =
    255u;
  static constexpr uint8_t MESSAGE_ID_MIN =
    0u;
  static constexpr uint8_t MESSAGE_ID_MAX =
    255u;
  static constexpr uint8_t MESSAGE_ID_DENM =
    1u;
  static constexpr uint8_t MESSAGE_ID_CAM =
    2u;
  static constexpr uint8_t MESSAGE_ID_POI =
    3u;
  static constexpr uint8_t MESSAGE_ID_SPATEM =
    4u;
  static constexpr uint8_t MESSAGE_ID_MAPEM =
    5u;
  static constexpr uint8_t MESSAGE_ID_IVIM =
    6u;
  static constexpr uint8_t MESSAGE_ID_EV_RSR =
    7u;
  static constexpr uint8_t MESSAGE_ID_TISTPGTRANSACTION =
    8u;
  static constexpr uint8_t MESSAGE_ID_SREM =
    9u;
  static constexpr uint8_t MESSAGE_ID_SSEM =
    10u;
  static constexpr uint8_t MESSAGE_ID_EVCSN =
    11u;
  static constexpr uint8_t MESSAGE_ID_SAEM =
    12u;
  static constexpr uint8_t MESSAGE_ID_RTCMEM =
    13u;

  // pointer types
  using RawPtr =
    etsi_its_denm_msgs::msg::ItsPduHeader_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_denm_msgs::msg::ItsPduHeader_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_denm_msgs::msg::ItsPduHeader_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_denm_msgs::msg::ItsPduHeader_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_msgs::msg::ItsPduHeader_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_msgs::msg::ItsPduHeader_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_msgs::msg::ItsPduHeader_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_msgs::msg::ItsPduHeader_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_denm_msgs::msg::ItsPduHeader_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_denm_msgs::msg::ItsPduHeader_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_denm_msgs__msg__ItsPduHeader
    std::shared_ptr<etsi_its_denm_msgs::msg::ItsPduHeader_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_denm_msgs__msg__ItsPduHeader
    std::shared_ptr<etsi_its_denm_msgs::msg::ItsPduHeader_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ItsPduHeader_ & other) const
  {
    if (this->protocol_version != other.protocol_version) {
      return false;
    }
    if (this->message_id != other.message_id) {
      return false;
    }
    if (this->station_id != other.station_id) {
      return false;
    }
    return true;
  }
  bool operator!=(const ItsPduHeader_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ItsPduHeader_

// alias to use template instance with default allocator
using ItsPduHeader =
  etsi_its_denm_msgs::msg::ItsPduHeader_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ItsPduHeader_<ContainerAllocator>::PROTOCOL_VERSION_MIN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ItsPduHeader_<ContainerAllocator>::PROTOCOL_VERSION_MAX;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ItsPduHeader_<ContainerAllocator>::MESSAGE_ID_MIN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ItsPduHeader_<ContainerAllocator>::MESSAGE_ID_MAX;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ItsPduHeader_<ContainerAllocator>::MESSAGE_ID_DENM;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ItsPduHeader_<ContainerAllocator>::MESSAGE_ID_CAM;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ItsPduHeader_<ContainerAllocator>::MESSAGE_ID_POI;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ItsPduHeader_<ContainerAllocator>::MESSAGE_ID_SPATEM;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ItsPduHeader_<ContainerAllocator>::MESSAGE_ID_MAPEM;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ItsPduHeader_<ContainerAllocator>::MESSAGE_ID_IVIM;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ItsPduHeader_<ContainerAllocator>::MESSAGE_ID_EV_RSR;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ItsPduHeader_<ContainerAllocator>::MESSAGE_ID_TISTPGTRANSACTION;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ItsPduHeader_<ContainerAllocator>::MESSAGE_ID_SREM;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ItsPduHeader_<ContainerAllocator>::MESSAGE_ID_SSEM;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ItsPduHeader_<ContainerAllocator>::MESSAGE_ID_EVCSN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ItsPduHeader_<ContainerAllocator>::MESSAGE_ID_SAEM;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ItsPduHeader_<ContainerAllocator>::MESSAGE_ID_RTCMEM;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_denm_msgs

#endif  // ETSI_ITS_DENM_MSGS__MSG__DETAIL__ITS_PDU_HEADER__STRUCT_HPP_
