// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_denm_msgs:msg/LateralAcceleration.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_denm_msgs/msg/lateral_acceleration.hpp"


#ifndef ETSI_ITS_DENM_MSGS__MSG__DETAIL__LATERAL_ACCELERATION__STRUCT_HPP_
#define ETSI_ITS_DENM_MSGS__MSG__DETAIL__LATERAL_ACCELERATION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'lateral_acceleration_value'
#include "etsi_its_denm_msgs/msg/detail/lateral_acceleration_value__struct.hpp"
// Member 'lateral_acceleration_confidence'
#include "etsi_its_denm_msgs/msg/detail/acceleration_confidence__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_denm_msgs__msg__LateralAcceleration __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_denm_msgs__msg__LateralAcceleration __declspec(deprecated)
#endif

namespace etsi_its_denm_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct LateralAcceleration_
{
  using Type = LateralAcceleration_<ContainerAllocator>;

  explicit LateralAcceleration_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : lateral_acceleration_value(_init),
    lateral_acceleration_confidence(_init)
  {
    (void)_init;
  }

  explicit LateralAcceleration_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : lateral_acceleration_value(_alloc, _init),
    lateral_acceleration_confidence(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _lateral_acceleration_value_type =
    etsi_its_denm_msgs::msg::LateralAccelerationValue_<ContainerAllocator>;
  _lateral_acceleration_value_type lateral_acceleration_value;
  using _lateral_acceleration_confidence_type =
    etsi_its_denm_msgs::msg::AccelerationConfidence_<ContainerAllocator>;
  _lateral_acceleration_confidence_type lateral_acceleration_confidence;

  // setters for named parameter idiom
  Type & set__lateral_acceleration_value(
    const etsi_its_denm_msgs::msg::LateralAccelerationValue_<ContainerAllocator> & _arg)
  {
    this->lateral_acceleration_value = _arg;
    return *this;
  }
  Type & set__lateral_acceleration_confidence(
    const etsi_its_denm_msgs::msg::AccelerationConfidence_<ContainerAllocator> & _arg)
  {
    this->lateral_acceleration_confidence = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_denm_msgs::msg::LateralAcceleration_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_denm_msgs::msg::LateralAcceleration_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_denm_msgs::msg::LateralAcceleration_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_denm_msgs::msg::LateralAcceleration_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_msgs::msg::LateralAcceleration_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_msgs::msg::LateralAcceleration_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_msgs::msg::LateralAcceleration_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_msgs::msg::LateralAcceleration_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_denm_msgs::msg::LateralAcceleration_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_denm_msgs::msg::LateralAcceleration_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_denm_msgs__msg__LateralAcceleration
    std::shared_ptr<etsi_its_denm_msgs::msg::LateralAcceleration_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_denm_msgs__msg__LateralAcceleration
    std::shared_ptr<etsi_its_denm_msgs::msg::LateralAcceleration_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const LateralAcceleration_ & other) const
  {
    if (this->lateral_acceleration_value != other.lateral_acceleration_value) {
      return false;
    }
    if (this->lateral_acceleration_confidence != other.lateral_acceleration_confidence) {
      return false;
    }
    return true;
  }
  bool operator!=(const LateralAcceleration_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct LateralAcceleration_

// alias to use template instance with default allocator
using LateralAcceleration =
  etsi_its_denm_msgs::msg::LateralAcceleration_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_denm_msgs

#endif  // ETSI_ITS_DENM_MSGS__MSG__DETAIL__LATERAL_ACCELERATION__STRUCT_HPP_
