// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_denm_msgs:msg/ManagementContainer.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_denm_msgs/msg/management_container.h"


#ifndef ETSI_ITS_DENM_MSGS__MSG__DETAIL__MANAGEMENT_CONTAINER__STRUCT_H_
#define ETSI_ITS_DENM_MSGS__MSG__DETAIL__MANAGEMENT_CONTAINER__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'DEFAULT_VALIDITY_DURATION'.
enum
{
  etsi_its_denm_msgs__msg__ManagementContainer__DEFAULT_VALIDITY_DURATION = 600
};

// Include directives for member types
// Member 'action_id'
#include "etsi_its_denm_msgs/msg/detail/action_id__struct.h"
// Member 'detection_time'
// Member 'reference_time'
#include "etsi_its_denm_msgs/msg/detail/timestamp_its__struct.h"
// Member 'termination'
#include "etsi_its_denm_msgs/msg/detail/termination__struct.h"
// Member 'event_position'
#include "etsi_its_denm_msgs/msg/detail/reference_position__struct.h"
// Member 'relevance_distance'
#include "etsi_its_denm_msgs/msg/detail/relevance_distance__struct.h"
// Member 'relevance_traffic_direction'
#include "etsi_its_denm_msgs/msg/detail/relevance_traffic_direction__struct.h"
// Member 'validity_duration'
#include "etsi_its_denm_msgs/msg/detail/validity_duration__struct.h"
// Member 'transmission_interval'
#include "etsi_its_denm_msgs/msg/detail/transmission_interval__struct.h"
// Member 'station_type'
#include "etsi_its_denm_msgs/msg/detail/station_type__struct.h"

/// Struct defined in msg/ManagementContainer in the package etsi_its_denm_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_denm_msgs__msg__ManagementContainer
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// ManagementContainer ::= SEQUENCE {
  ///  actionID ActionID,
  ///  detectionTime TimestampIts,
  ///  referenceTime TimestampIts,
  ///  termination Termination OPTIONAL,
  ///  eventPosition ReferencePosition,
  ///  relevanceDistance RelevanceDistance OPTIONAL,
  ///  relevanceTrafficDirection RelevanceTrafficDirection OPTIONAL,
  ///  validityDuration ValidityDuration DEFAULT defaultValidity,
  ///  transmissionInterval TransmissionInterval OPTIONAL,
  ///  stationType StationType,
  ///  ...
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_denm_msgs__msg__ActionID action_id;
  etsi_its_denm_msgs__msg__TimestampIts detection_time;
  etsi_its_denm_msgs__msg__TimestampIts reference_time;
  etsi_its_denm_msgs__msg__Termination termination;
  bool termination_is_present;
  etsi_its_denm_msgs__msg__ReferencePosition event_position;
  etsi_its_denm_msgs__msg__RelevanceDistance relevance_distance;
  bool relevance_distance_is_present;
  etsi_its_denm_msgs__msg__RelevanceTrafficDirection relevance_traffic_direction;
  bool relevance_traffic_direction_is_present;
  etsi_its_denm_msgs__msg__ValidityDuration validity_duration;
  etsi_its_denm_msgs__msg__TransmissionInterval transmission_interval;
  bool transmission_interval_is_present;
  etsi_its_denm_msgs__msg__StationType station_type;
} etsi_its_denm_msgs__msg__ManagementContainer;

// Struct for a sequence of etsi_its_denm_msgs__msg__ManagementContainer.
typedef struct etsi_its_denm_msgs__msg__ManagementContainer__Sequence
{
  etsi_its_denm_msgs__msg__ManagementContainer * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_denm_msgs__msg__ManagementContainer__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_DENM_MSGS__MSG__DETAIL__MANAGEMENT_CONTAINER__STRUCT_H_
