// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_denm_msgs:msg/ManagementContainer.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_denm_msgs/msg/management_container.hpp"


#ifndef ETSI_ITS_DENM_MSGS__MSG__DETAIL__MANAGEMENT_CONTAINER__TRAITS_HPP_
#define ETSI_ITS_DENM_MSGS__MSG__DETAIL__MANAGEMENT_CONTAINER__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_denm_msgs/msg/detail/management_container__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'action_id'
#include "etsi_its_denm_msgs/msg/detail/action_id__traits.hpp"
// Member 'detection_time'
// Member 'reference_time'
#include "etsi_its_denm_msgs/msg/detail/timestamp_its__traits.hpp"
// Member 'termination'
#include "etsi_its_denm_msgs/msg/detail/termination__traits.hpp"
// Member 'event_position'
#include "etsi_its_denm_msgs/msg/detail/reference_position__traits.hpp"
// Member 'relevance_distance'
#include "etsi_its_denm_msgs/msg/detail/relevance_distance__traits.hpp"
// Member 'relevance_traffic_direction'
#include "etsi_its_denm_msgs/msg/detail/relevance_traffic_direction__traits.hpp"
// Member 'validity_duration'
#include "etsi_its_denm_msgs/msg/detail/validity_duration__traits.hpp"
// Member 'transmission_interval'
#include "etsi_its_denm_msgs/msg/detail/transmission_interval__traits.hpp"
// Member 'station_type'
#include "etsi_its_denm_msgs/msg/detail/station_type__traits.hpp"

namespace etsi_its_denm_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const ManagementContainer & msg,
  std::ostream & out)
{
  out << "{";
  // member: action_id
  {
    out << "action_id: ";
    to_flow_style_yaml(msg.action_id, out);
    out << ", ";
  }

  // member: detection_time
  {
    out << "detection_time: ";
    to_flow_style_yaml(msg.detection_time, out);
    out << ", ";
  }

  // member: reference_time
  {
    out << "reference_time: ";
    to_flow_style_yaml(msg.reference_time, out);
    out << ", ";
  }

  // member: termination
  {
    out << "termination: ";
    to_flow_style_yaml(msg.termination, out);
    out << ", ";
  }

  // member: termination_is_present
  {
    out << "termination_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.termination_is_present, out);
    out << ", ";
  }

  // member: event_position
  {
    out << "event_position: ";
    to_flow_style_yaml(msg.event_position, out);
    out << ", ";
  }

  // member: relevance_distance
  {
    out << "relevance_distance: ";
    to_flow_style_yaml(msg.relevance_distance, out);
    out << ", ";
  }

  // member: relevance_distance_is_present
  {
    out << "relevance_distance_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.relevance_distance_is_present, out);
    out << ", ";
  }

  // member: relevance_traffic_direction
  {
    out << "relevance_traffic_direction: ";
    to_flow_style_yaml(msg.relevance_traffic_direction, out);
    out << ", ";
  }

  // member: relevance_traffic_direction_is_present
  {
    out << "relevance_traffic_direction_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.relevance_traffic_direction_is_present, out);
    out << ", ";
  }

  // member: validity_duration
  {
    out << "validity_duration: ";
    to_flow_style_yaml(msg.validity_duration, out);
    out << ", ";
  }

  // member: transmission_interval
  {
    out << "transmission_interval: ";
    to_flow_style_yaml(msg.transmission_interval, out);
    out << ", ";
  }

  // member: transmission_interval_is_present
  {
    out << "transmission_interval_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.transmission_interval_is_present, out);
    out << ", ";
  }

  // member: station_type
  {
    out << "station_type: ";
    to_flow_style_yaml(msg.station_type, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ManagementContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: action_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "action_id:\n";
    to_block_style_yaml(msg.action_id, out, indentation + 2);
  }

  // member: detection_time
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "detection_time:\n";
    to_block_style_yaml(msg.detection_time, out, indentation + 2);
  }

  // member: reference_time
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "reference_time:\n";
    to_block_style_yaml(msg.reference_time, out, indentation + 2);
  }

  // member: termination
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "termination:\n";
    to_block_style_yaml(msg.termination, out, indentation + 2);
  }

  // member: termination_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "termination_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.termination_is_present, out);
    out << "\n";
  }

  // member: event_position
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "event_position:\n";
    to_block_style_yaml(msg.event_position, out, indentation + 2);
  }

  // member: relevance_distance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "relevance_distance:\n";
    to_block_style_yaml(msg.relevance_distance, out, indentation + 2);
  }

  // member: relevance_distance_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "relevance_distance_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.relevance_distance_is_present, out);
    out << "\n";
  }

  // member: relevance_traffic_direction
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "relevance_traffic_direction:\n";
    to_block_style_yaml(msg.relevance_traffic_direction, out, indentation + 2);
  }

  // member: relevance_traffic_direction_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "relevance_traffic_direction_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.relevance_traffic_direction_is_present, out);
    out << "\n";
  }

  // member: validity_duration
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "validity_duration:\n";
    to_block_style_yaml(msg.validity_duration, out, indentation + 2);
  }

  // member: transmission_interval
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "transmission_interval:\n";
    to_block_style_yaml(msg.transmission_interval, out, indentation + 2);
  }

  // member: transmission_interval_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "transmission_interval_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.transmission_interval_is_present, out);
    out << "\n";
  }

  // member: station_type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "station_type:\n";
    to_block_style_yaml(msg.station_type, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ManagementContainer & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_denm_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_denm_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_denm_msgs::msg::ManagementContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_denm_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_denm_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_denm_msgs::msg::ManagementContainer & msg)
{
  return etsi_its_denm_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_denm_msgs::msg::ManagementContainer>()
{
  return "etsi_its_denm_msgs::msg::ManagementContainer";
}

template<>
inline const char * name<etsi_its_denm_msgs::msg::ManagementContainer>()
{
  return "etsi_its_denm_msgs/msg/ManagementContainer";
}

template<>
struct has_fixed_size<etsi_its_denm_msgs::msg::ManagementContainer>
  : std::integral_constant<bool, has_fixed_size<etsi_its_denm_msgs::msg::ActionID>::value && has_fixed_size<etsi_its_denm_msgs::msg::ReferencePosition>::value && has_fixed_size<etsi_its_denm_msgs::msg::RelevanceDistance>::value && has_fixed_size<etsi_its_denm_msgs::msg::RelevanceTrafficDirection>::value && has_fixed_size<etsi_its_denm_msgs::msg::StationType>::value && has_fixed_size<etsi_its_denm_msgs::msg::Termination>::value && has_fixed_size<etsi_its_denm_msgs::msg::TimestampIts>::value && has_fixed_size<etsi_its_denm_msgs::msg::TransmissionInterval>::value && has_fixed_size<etsi_its_denm_msgs::msg::ValidityDuration>::value> {};

template<>
struct has_bounded_size<etsi_its_denm_msgs::msg::ManagementContainer>
  : std::integral_constant<bool, has_bounded_size<etsi_its_denm_msgs::msg::ActionID>::value && has_bounded_size<etsi_its_denm_msgs::msg::ReferencePosition>::value && has_bounded_size<etsi_its_denm_msgs::msg::RelevanceDistance>::value && has_bounded_size<etsi_its_denm_msgs::msg::RelevanceTrafficDirection>::value && has_bounded_size<etsi_its_denm_msgs::msg::StationType>::value && has_bounded_size<etsi_its_denm_msgs::msg::Termination>::value && has_bounded_size<etsi_its_denm_msgs::msg::TimestampIts>::value && has_bounded_size<etsi_its_denm_msgs::msg::TransmissionInterval>::value && has_bounded_size<etsi_its_denm_msgs::msg::ValidityDuration>::value> {};

template<>
struct is_message<etsi_its_denm_msgs::msg::ManagementContainer>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_DENM_MSGS__MSG__DETAIL__MANAGEMENT_CONTAINER__TRAITS_HPP_
