// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_denm_msgs:msg/SituationContainer.idl
// generated code does not contain a copyright notice
#include "etsi_its_denm_msgs/msg/detail/situation_container__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `information_quality`
#include "etsi_its_denm_msgs/msg/detail/information_quality__functions.h"
// Member `event_type`
// Member `linked_cause`
#include "etsi_its_denm_msgs/msg/detail/cause_code__functions.h"
// Member `event_history`
#include "etsi_its_denm_msgs/msg/detail/event_history__functions.h"

bool
etsi_its_denm_msgs__msg__SituationContainer__init(etsi_its_denm_msgs__msg__SituationContainer * msg)
{
  if (!msg) {
    return false;
  }
  // information_quality
  if (!etsi_its_denm_msgs__msg__InformationQuality__init(&msg->information_quality)) {
    etsi_its_denm_msgs__msg__SituationContainer__fini(msg);
    return false;
  }
  // event_type
  if (!etsi_its_denm_msgs__msg__CauseCode__init(&msg->event_type)) {
    etsi_its_denm_msgs__msg__SituationContainer__fini(msg);
    return false;
  }
  // linked_cause
  if (!etsi_its_denm_msgs__msg__CauseCode__init(&msg->linked_cause)) {
    etsi_its_denm_msgs__msg__SituationContainer__fini(msg);
    return false;
  }
  // linked_cause_is_present
  // event_history
  if (!etsi_its_denm_msgs__msg__EventHistory__init(&msg->event_history)) {
    etsi_its_denm_msgs__msg__SituationContainer__fini(msg);
    return false;
  }
  // event_history_is_present
  return true;
}

void
etsi_its_denm_msgs__msg__SituationContainer__fini(etsi_its_denm_msgs__msg__SituationContainer * msg)
{
  if (!msg) {
    return;
  }
  // information_quality
  etsi_its_denm_msgs__msg__InformationQuality__fini(&msg->information_quality);
  // event_type
  etsi_its_denm_msgs__msg__CauseCode__fini(&msg->event_type);
  // linked_cause
  etsi_its_denm_msgs__msg__CauseCode__fini(&msg->linked_cause);
  // linked_cause_is_present
  // event_history
  etsi_its_denm_msgs__msg__EventHistory__fini(&msg->event_history);
  // event_history_is_present
}

bool
etsi_its_denm_msgs__msg__SituationContainer__are_equal(const etsi_its_denm_msgs__msg__SituationContainer * lhs, const etsi_its_denm_msgs__msg__SituationContainer * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // information_quality
  if (!etsi_its_denm_msgs__msg__InformationQuality__are_equal(
      &(lhs->information_quality), &(rhs->information_quality)))
  {
    return false;
  }
  // event_type
  if (!etsi_its_denm_msgs__msg__CauseCode__are_equal(
      &(lhs->event_type), &(rhs->event_type)))
  {
    return false;
  }
  // linked_cause
  if (!etsi_its_denm_msgs__msg__CauseCode__are_equal(
      &(lhs->linked_cause), &(rhs->linked_cause)))
  {
    return false;
  }
  // linked_cause_is_present
  if (lhs->linked_cause_is_present != rhs->linked_cause_is_present) {
    return false;
  }
  // event_history
  if (!etsi_its_denm_msgs__msg__EventHistory__are_equal(
      &(lhs->event_history), &(rhs->event_history)))
  {
    return false;
  }
  // event_history_is_present
  if (lhs->event_history_is_present != rhs->event_history_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_denm_msgs__msg__SituationContainer__copy(
  const etsi_its_denm_msgs__msg__SituationContainer * input,
  etsi_its_denm_msgs__msg__SituationContainer * output)
{
  if (!input || !output) {
    return false;
  }
  // information_quality
  if (!etsi_its_denm_msgs__msg__InformationQuality__copy(
      &(input->information_quality), &(output->information_quality)))
  {
    return false;
  }
  // event_type
  if (!etsi_its_denm_msgs__msg__CauseCode__copy(
      &(input->event_type), &(output->event_type)))
  {
    return false;
  }
  // linked_cause
  if (!etsi_its_denm_msgs__msg__CauseCode__copy(
      &(input->linked_cause), &(output->linked_cause)))
  {
    return false;
  }
  // linked_cause_is_present
  output->linked_cause_is_present = input->linked_cause_is_present;
  // event_history
  if (!etsi_its_denm_msgs__msg__EventHistory__copy(
      &(input->event_history), &(output->event_history)))
  {
    return false;
  }
  // event_history_is_present
  output->event_history_is_present = input->event_history_is_present;
  return true;
}

etsi_its_denm_msgs__msg__SituationContainer *
etsi_its_denm_msgs__msg__SituationContainer__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_denm_msgs__msg__SituationContainer * msg = (etsi_its_denm_msgs__msg__SituationContainer *)allocator.allocate(sizeof(etsi_its_denm_msgs__msg__SituationContainer), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_denm_msgs__msg__SituationContainer));
  bool success = etsi_its_denm_msgs__msg__SituationContainer__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_denm_msgs__msg__SituationContainer__destroy(etsi_its_denm_msgs__msg__SituationContainer * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_denm_msgs__msg__SituationContainer__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_denm_msgs__msg__SituationContainer__Sequence__init(etsi_its_denm_msgs__msg__SituationContainer__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_denm_msgs__msg__SituationContainer * data = NULL;

  if (size) {
    data = (etsi_its_denm_msgs__msg__SituationContainer *)allocator.zero_allocate(size, sizeof(etsi_its_denm_msgs__msg__SituationContainer), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_denm_msgs__msg__SituationContainer__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_denm_msgs__msg__SituationContainer__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_denm_msgs__msg__SituationContainer__Sequence__fini(etsi_its_denm_msgs__msg__SituationContainer__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_denm_msgs__msg__SituationContainer__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_denm_msgs__msg__SituationContainer__Sequence *
etsi_its_denm_msgs__msg__SituationContainer__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_denm_msgs__msg__SituationContainer__Sequence * array = (etsi_its_denm_msgs__msg__SituationContainer__Sequence *)allocator.allocate(sizeof(etsi_its_denm_msgs__msg__SituationContainer__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_denm_msgs__msg__SituationContainer__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_denm_msgs__msg__SituationContainer__Sequence__destroy(etsi_its_denm_msgs__msg__SituationContainer__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_denm_msgs__msg__SituationContainer__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_denm_msgs__msg__SituationContainer__Sequence__are_equal(const etsi_its_denm_msgs__msg__SituationContainer__Sequence * lhs, const etsi_its_denm_msgs__msg__SituationContainer__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_denm_msgs__msg__SituationContainer__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_denm_msgs__msg__SituationContainer__Sequence__copy(
  const etsi_its_denm_msgs__msg__SituationContainer__Sequence * input,
  etsi_its_denm_msgs__msg__SituationContainer__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_denm_msgs__msg__SituationContainer);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_denm_msgs__msg__SituationContainer * data =
      (etsi_its_denm_msgs__msg__SituationContainer *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_denm_msgs__msg__SituationContainer__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_denm_msgs__msg__SituationContainer__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_denm_msgs__msg__SituationContainer__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
